NPM     : 2306152494

Class   : Adpro-A

# Commit 1 Reflection Notes
In this commit, I implemented a basic web server connection using Rust and verified the response. The process of setting up a buffer stream in Rust is quite different from the approach used in JavaScript frameworks, which I found both challenging and rewarding. This implementation required a deeper understanding of Rust's memory management and ownership model, which helped me improve my programming skills. Additionally, I learned how to handle HTTP requests and responses in a low-level language, which provided valuable insights into how web servers operate under the hood. Overall, this experience was a great opportunity to explore Rust's capabilities and compare them with higher-level frameworks.

# Commit 2 Screen Capture
![Commit 2 screen capture](/assets/images/commit2.png)

# Commit 3 Screen Capture
![Commit 3 screen capture](/assets/images/commit3.png)

> How to split between response and why the refactoring is needed.
Currently, I split the response in this part of the code:
```rust
if http_request[0].as_bytes() == get
...
```

This code checks if the HTTP request is a GET request. If it matches, the server returns the appropriate response; otherwise, it sends a 404 response. While this approach works for basic functionality, it becomes increasingly difficult to manage as the application grows. The current implementation relies heavily on if-else statements, which can quickly become cluttered and hard to read. Refactoring is necessary to improve code readability and maintainability, especially when adding more responses or implementing complex routing logic. By adopting a more modular design, such as using a routing table or a dedicated request handler, the code can be made cleaner and easier to extend in the future.

# Commit 4 Reflection Notes
In this milestone, I identified a significant limitation in the server's design: it operated on a single thread, allowing it to process only one request at a time. To illustrate this bottleneck, I introduced a sleep function that delays the server's response by 10 seconds, simulating a slow request. This experiment effectively demonstrated the server's inability to handle multiple requests concurrently, underscoring the necessity of adopting a more efficient, multi-threaded architecture in future iterations.

# Commit 5 Reflection Notes
In this commit, I refactored the server to use a multi-threaded approach instead of a single-threaded one. This change allows the server to handle up to 4 requests simultaneously, significantly improving the response time compared to the single-threaded server. The multi-threaded implementation resolves the slow response issue that was present in the single-threaded server. Additionally, I learned how to manage thread pools effectively and ensure thread safety in Rust, which was a valuable learning experience. This refactoring not only enhanced the server's performance but also deepened my understanding of concurrent programming in Rust. Overall, this commit represents a significant step forward in building a more robust and scalable web server.